#!/usr/bin/env python3
"""
Generate Tests for Unproprietary
by Javantea
Sept 12, 2015

"""
import zlib
import gzip
import wave
import bz2
import lzma
# So many image formats =)
import PIL.Image
import tarfile
import io
SWFMovie = None
#try:
#	from ming import SWFMovie, SWFFont, SWFText
#except ImportError:
#	print("No ming, no SWF")
#end try
import elf1
libtorrent = None
try:
	import libtorrent
except ImportError:
	print("No libtorrent, no torrent")
#end try

sample_text = b'test\n'
sample_unicode = sample_text.decode('utf-8', errors='replace')

# zlib
open('test/zlib1.bin','wb').write(zlib.compress(sample_text))

# gzip
#echo "test" |gzip >test/gzip1.gz
gzip.GzipFile('test/gzip1.gz','wb').write(sample_text)

# BZip2
bz2.BZ2File('test/bzip21.bz2','wb').write(sample_text)

# XZ
lzma.LZMAFile('test/xz1.xz','wb').write(sample_text)

# Images
w, h = 10, 10
im = PIL.Image.frombytes('RGBA', (w, h), (sample_text*((w*h*4)//len(sample_text)))[:w*h*4])
# PNG
im.save('test/png1.png')
# GIF
im.save('test/gif1.gif')
# JPEG
im.save('test/jpeg1.jpg')

# InfoZip
zf = zipfile.ZipFile('test/zip1.zip','w')
zf.writestr('test.txt', sample_text)
zf.close()

# MP3
# FIXME: create an MP3 in Python dev-python/gst-python
# lame test/wave1.wav test/mp31.mp3

# Wave file
wf = wave.open('test/wave1.wav','wb')
# 16-bit stereo at 44100 Hz
wf.setnchannels(2)
wf.setsampwidth(2)
wf.setframerate(44100)
# to get a multiple of channels * sample_width == 4
wf.writeframes(sample_text * 4)
wf.close()

# AVI
# FIXME: create an AVI in Python dev-python/gst-python
# ffmpeg -i test/png1.png test/avi1.avi

# Ogg
# FIXME: create an Ogg in Python
# oggenc test/wave1.wav -o test/ogg1.ogg

# Tarball
tf = tarfile.TarFile('test/tar1.tar', 'w')
ti = tarfile.TarInfo('test.txt')
ti.size = len(sample_text)
tf.addfile(ti, io.BytesIO(sample_text))
tf.close()

# SWF
if SWFMovie:
	# This segfaults, so no.
	"""
	m = SWFMovie()
	font = SWFBrowserFont("_sans")
	text = SWFText(2)
	text.setFont(font)
	text.setColor(0, 0, 0, 0xff)
	text.setHeight(20)
	text.addString(sample_unicode)
	m.add(text)
	m.save("test/swf1.swf")
	"""
#end if

# Rar
# FIXME: find a way to create a Rar file in Python =/
# Are there any open source Rar file creators? I'm seeing...

# 7zip LZMA file
# FIXME: create a 7z file in Python
# echo test >test1.txt && 7za a -t7z -m0=lzma -mx=9 -mfb=64 -md=32m -ms=on test/lzma1.7z test1.txt && rm test1.txt

# ELF
# Create an elf using JavRE...
# echo | gcc -x c -c -o test/elf1.elf -
e = elf1.elf_header(b'\x00'*64, error='ignore')
e.default()
open('test/elf1.elf', 'wb').write(e.out())

# Shell Script
open('test/sh1.sh','wb').write(b'#!/bin/bash\n# Testing.\nexit 1\n')


# Python script
open('test/python1.py','wb').write(b'#!/usr/bin/env python3\n"""\nTesting.\n"""\nexit(1)\n')

# PDF
# FIXME: create a PDF file in Python
# echo '# Test' > test.md; pandoc -f markdown -t latex -o test/pdf1.pdf test.md; rm test.md
# PDF files will always have a bunch of false positives because it uses zlib a 
# lot.

# BitTorrent file
if libtorrent:
	# If anyone accidentally adds this torrent to their client, it'll hit my server =)
	d = {'announce':'https://www.altsci.com/concepts/unproprietary/tracker/announce', 
		'creation date': 1442270423,
		'info':{'length': 1234567, 'piece length': 0x40000, 'name':'test1.xz', 
		'private': 0, 'pieces': (b'\x00' * 20*5)}
		}
	open('test/torrent1.torrent','wb').write(libtorrent.bencode(d))
#end if

# FLAC
# FIXME: create an FLAC in Python
# flac -o test/flac1.flac test/wave1.wav
